/*********************************************************************
 *                 Flowcode AT90CAN CAN Driver Code
 *
 * File: Custom_Code.c
 *
 * (c) 2009 Matrix Multimedia Ltd.
 * http://www.matrixmultimedia.com
 *
 * Software License Agreement
 *
 * The software supplied herewith by Matrix Multimedia Ltd (the
 * Company) for its Flowcode graphical programming language is
 * intended and supplied to you, the Companys customer, for use
 * solely and exclusively on the Company's products. The software
 * is owned by the Company, and is protected under applicable
 * copyright laws. All rights are reserved. Any use in violation
 * of the foregoing restrictions may subject the user to criminal
 * sanctions under applicable laws, as well as to civil liability
 * for the breach of the terms and conditions of this licence.
 *
 * THIS SOFTWARE IS PROVIDED IN AN AS IS CONDITION. NO WARRANTIES,
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 * Changelog:
 *
 *  date  | by | description
 * -------+----+-----------------------------------------------------
 * 170409 | BR | Created
 *
 ********************************************************************/

/*********************************************************************

 Return & parameter types:
   void
   char
   short
   char*

 Pin directions:
   0 = OUTPUT
   2 = INPUT
   3 = BIDIRECTIONAL

 Macro substitutions:
   %a = ??
   %b = ??
   %c = ??
   %d = ??
   %e = ??
   %f = ??
   %g = ??
   %h = ??
   %i = ??
   %j = ??

**********************************************************************

[Settings]
CLSID={4B174520-75AB-4B14-A0F7-2AA6C203F1DC}
IsAnalogue=0
MultipleAllowed=0
Description=Custom Flowcode AT90CAN CAN Driver Component

**********************************************************************

[Port]
DesiredPort=0
PortMandatory=0
SamePortAsID=0

[Pins]
Count=0

[PinPort]
# PORTA = 0
# PORTB = 1
# PORTC = 2
# PORTD = 3
# PORTE = 4

[PinDesiredBit]

[PinDirection]
# DIR_INPUT = 2
# DIR_OUTPUT = 0
# DIR_BIDIRECTIONAL = 3

[PinMustUsePort]
# boolean

[SamePortAsPinX]
# -1 = any pin
# otherwise, the pin number

[PinMustUsePin]
# boolean

[PinValue]
# boolean (0 = off, 1 = on)

**********************************************************************

[MacroNames]
Count=17
1=GetDefines
2=Can_clear_all_MOB
3=Can_get_MOB_free
4=Can_get_MOB_status
5=Can_get_data
6=can_init
7=can_cmd
8=can_getstatus
9=Init
10=SendBuffer
11=CheckRx
12=GetRxDataCount
13=GetRxData
14=SetTxData
15=SetTxID
16=GetRxIDLo
17=GetRxIDHi

[MacroReturns]
1=void
2=void
3=char
4=char
5=void
6=void
7=char
8=char
9=void
10=void
11=char
12=char
13=char
14=void
15=void
16=char
17=char

[MacroIsPrivate]
1=1
2=1
3=1
4=1
5=1
6=1
7=1
8=1
9=0
10=0
11=0
12=0
13=0
14=0
15=0
16=0
17=0

[MacroParameters_GetDefines]
Count=0

[MacroParamTypes_GetDefines]


[MacroParameters_Can_clear_all_MOB]
Count=0

[MacroParamTypes_Can_clear_all_MOB]


[MacroParameters_Can_get_MOB_free]
Count=0

[MacroParamTypes_Can_get_MOB_free]


[MacroParameters_Can_get_MOB_status]
Count=0

[MacroParamTypes_Can_get_MOB_status]


[MacroParameters_Can_get_data]
Count=1
1=pt_data

[MacroParamTypes_Can_get_data]
1=char*

[MacroParameters_can_init]
Count=0

[MacroParamTypes_can_init]


[MacroParameters_can_cmd]
Count=1
1=cmd

[MacroParamTypes_can_cmd]
1=st_cmd_t*


[MacroParameters_can_getstatus]
Count=1
1=cmd

[MacroParamTypes_can_getstatus]
1=st_cmd_t*

[MacroParameters_Init]
Count=0

[MacroParamTypes_Init]


[MacroParameters_SendBuffer]
Count=0

[MacroParamTypes_SendBuffer]


[MacroParameters_CheckRx]
Count=0

[MacroParamTypes_CheckRx]


[MacroParameters_GetRxDataCount]
Count=0

[MacroParamTypes_GetRxDataCount]

[MacroParameters_GetRxData]
Count=1
1=index

[MacroParamTypes_GetRxData]
1=char

[MacroParameters_SetTxData]
Count=9
1=data_cnt
2=d0
3=d1
4=d2
5=d3
6=d4
7=d5
8=d6
9=d7

[MacroParamTypes_SetTxData]
1=char
2=char
3=char
4=char
5=char
6=char
7=char
8=char
9=char

[MacroParameters_SetTxID]
Count=2
1=hi
2=lo

[MacroParamTypes_SetTxID]
1=char
2=char

[MacroParameters_GetRxIDLo]
Count=0

[MacroParamTypes_GetRxIDLo]

[MacroParameters_GetRxIDHi]
Count=0

[MacroParamTypes_GetRxIDHi]

 ********************************************************************/

/********************************************************************
 * ADDITIONAL CODE
 ********************************************************************/

/*InitialisationCode_Start*/

	rx_msg.pt_data = &rx_buffer[0];
	rx_msg.status = 0;
	rx_msg.handle = 0;

	tx_msg.pt_data = &tx_buffer[0];
	tx_msg.status = 0;
	tx_msg.handle = 0;

	FCD_CAN0_can_init();

/*InitialisationCode_End*/

/*InterruptCode_Start*/
/*InterruptCode_End*/

/********************************************************************
 * FUNCTIONS
 ********************************************************************/

void GetDefines()
{
/*Macro_GetDefines_Start*/

}  //Dummy end of function to allow defines to be added correctly

//Global variables
st_cmd_t rx_msg;
st_cmd_t tx_msg;
char tx_buffer[8];
char rx_buffer[8];

//Constant Declarations
#define CAN_CMD_REFUSED  			0xFF		//return value for the function can_cmd
#define CAN_CMD_ACCEPTED 			0x00		//return value for the function can_cmd
#define CAN_STATUS_COMPLETED     	0x00		//return value for the function can_getstatus
#define CAN_STATUS_NOT_COMPLETED 	0x01		//return value for the function can_getstatus
#define CAN_STATUS_DISABLED      	0x02		//return value for the function can_getstatus
#define NB_MOB      				15
#define NB_DATA_MAX 				8
#define LAST_MOB_NB 				14
#define NO_MOB 						0xFF
#define CH_TxENA   					1
#define CH_RxENA   					2
#define CH_RxBENA  					3
#define STATUS_MOB_USED      		0x01
#define STATUS_MOB_AVAILABLE 		0x00

//Constants returned by the function CAN_get_MOb_status
#define MOB_TX_COMPLETED    0x00
#define MOB_RX_COMPLETED    0x01
#define MOB_NOT_COMPLETED   0x02
#define MOB_DISABLE         0xFF

//CAN Enable function declaration
#define Can_enable()    { CANGCON |= (1<<ENA); }
#define Can_bit_timing() {CANBT1=CONF_CANBT1;CANBT2=CONF_CANBT2;CANBT3=CONF_CANBT3;}
#define Can_set_MOB(mob) (CANPAGE = (mob << 4))
#define Can_clear_MOB()  {CANSTMOB = 0x00; CANCDMOB = 0x00; CANIDM1=0x00; \
                          CANIDM2=0x00; CANIDM3=0x00; CANIDM4=0x00; CANIDT4 = 0x00;}
#define Can_set_dlc(dlc) {CANCDMOB|=dlc;}		//MOB configuration

//Identifier definition
#define CAN_SET_STD_ID_10_4(identifier) (((*((char *)(&identifier)+1))<<5)+((*(char *)(&identifier))>>3))
#define CAN_SET_STD_ID_3_0(identifier)  ((*(char *)(&identifier))<<5)
#define Can_set_std_id(identifier) {\
        CANIDT1 = CAN_SET_STD_ID_10_4 (identifier);\
        CANIDT2 = CAN_SET_STD_ID_3_0  (identifier);}
#define Can_set_std_remote_id(identifier) {\
        CANIDT1 = CAN_SET_STD_ID_10_4 (identifier);\
        CANIDT2 = CAN_SET_STD_ID_3_0  (identifier);\
        CANIDT4 = (1<<RTRTAG);}
#define CAN_SET_EXT_ID_28_21(identifier) (((*((char *)(&identifier)+3))<<3)+((*((char *)(&identifier)+2))>>5))
#define CAN_SET_EXT_ID_20_13(identifier) (((*((char *)(&identifier)+2))<<3)+((*((char *)(&identifier)+1))>>5))
#define CAN_SET_EXT_ID_12_5(identifier)  (((*((char *)(&identifier)+1))<<3)+((* (char *)(&identifier)   )>>5))
#define CAN_SET_EXT_ID_4_0(identifier)    ((* (char *)(&identifier)   )<<3)
#define Can_set_ext_id(identifier) {\
        CANIDT1 = CAN_SET_EXT_ID_28_21 (identifier);\
        CANIDT2 = CAN_SET_EXT_ID_20_13 (identifier);\
        CANIDT3 = CAN_SET_EXT_ID_12_5  (identifier);\
        CANIDT4 = CAN_SET_EXT_ID_4_0   (identifier);\
        CANCDMOB |= (1<<IDE); }
#define Can_set_ext_remote_id(identifier) {\
        CANIDT1 = CAN_SET_EXT_ID_28_21 (identifier);\
        CANIDT2 = CAN_SET_EXT_ID_20_13 (identifier);\
        CANIDT3 = CAN_SET_EXT_ID_12_5  (identifier);\
        CANIDT4 = CAN_SET_EXT_ID_4_0   (identifier);\
        CANCDMOB |= (1<<IDE); \
        CANIDT4 |= (1<<RTRTAG);}
#define Can_get_ext_id(identifier){     \
        *((char *)(&identifier)+3) = CANIDT1>>3;   \
        *((char *)(&identifier)+2) = (CANIDT2>>3)+(CANIDT1<<5);   \
        *((char *)(&identifier)+1) = (CANIDT3>>3)+(CANIDT2<<5);   \
        *((char *)(&identifier))   = (CANIDT4>>3)+(CANIDT3<<5);  }
#define Can_get_std_id(identifier){  \
        *((char *)(&identifier)+1) = CANIDT1>>5; \
        *((char *)(&identifier)  ) = (CANIDT2>>5)+(CANIDT1<<3); }
#define DISABLE_CHANNEL        ( CANCDMOB &= (~CONMOB_msk) )
#define Can_config_tx()      { CANCDMOB |=  (CH_TxENA  << CONMOB); }
#define Can_config_rx()      { DISABLE_CHANNEL ; CANCDMOB |=  (CH_RxENA  << CONMOB); }
#define Can_config_rxbuffer() { DISABLE_CHANNEL ; CANCDMOB |=  (CH_RxBENA << CONMOB); }

#define Can_MOB_abort()   {CANCDMOB &= (~CONMOB_msk);}
#define Can_get_dlc()     (CANCDMOB & DLC_msk)
#define Can_get_ide()     (CANCDMOB & (1<<IDE))
#define Can_get_rtr()     ((CANIDT4 & (1<<RTRTAG))>>RTRTAG)


//Baud rate of 125kbs - Default CAN E-block compatible baud rate

#if F_CPU == 4000000UL			//4MHz Operation
    #define CONF_CANBT1  0x02
    #define CONF_CANBT2  0x0C
    #define CONF_CANBT3  0x37
#endif
#if F_CPU == 6000000UL			//6MHz Operation
    #define CONF_CANBT1  0x04
    #define CONF_CANBT2  0x0C
    #define CONF_CANBT3  0x37
#endif
#if F_CPU == 8000000UL			//8MHz Operation
    #define CONF_CANBT1  0x06
    #define CONF_CANBT2  0x0C
    #define CONF_CANBT3  0x37
#endif
#if F_CPU == 12000000UL			//12MHz Operation
    #define CONF_CANBT1  0x0A
    #define CONF_CANBT2  0x0C
    #define CONF_CANBT3  0x37
#endif
#if F_CPU == 16000000UL			//16MHz Operation
    #define CONF_CANBT1  0x0E
    #define CONF_CANBT2  0x0C
    #define CONF_CANBT3  0x37
#endif
#if F_CPU == 18000000UL			//18MHz Operation - Guessed value!!
    #define CONF_CANBT1  0x10
    #define CONF_CANBT2  0x0C
    #define CONF_CANBT3  0x37
#endif
#if F_CPU == 20000000UL			//20MHz Operation - Guessed value!!
    #define CONF_CANBT1  0x12
    #define CONF_CANBT2  0x0C
    #define CONF_CANBT3  0x37
#endif
#ifndef CONF_CANBT1
  #error the baud values relative to this clock speed have not been specified
#endif



// Dummy function to close the defines section off
void Internal_CAN_Driver_Dummy_Function();
void Internal_CAN_Driver_Dummy_Function()
{

/*Macro_GetDefines_End*/
}


/* FUNCTION_NAME: Can_clear_all_MOB
 * PURPOSE: This function clears the Mailbox content.*/
void Can_clear_all_MOB (void)
{
/*Macro_Can_clear_all_MOB_Start*/
  char num_mob, num_data;

  for (num_mob = 0; num_mob < NB_MOB; num_mob++)
  {
    CANPAGE  = (num_mob << 4);
    CANSTMOB = 0;
    CANCDMOB = 0;
    CANIDT4  = 0;
    CANIDT3  = 0;
    CANIDT2  = 0;
    CANIDT1  = 0;
    CANIDM4  = 0;
    CANIDM3  = 0;
    CANIDM2  = 0;
    CANIDM1  = 0;
    for (num_data = 0; num_data < NB_DATA_MAX; num_data++)
    {
      CANMSG = 0;
    }
  }
/*Macro_Can_clear_all_MOB_End*/
}


/* FUNCTION_NAME: Can_get_MOB_free
 * return:   handle of MOb
 * PURPOSE: This function return the number of the first MOb available
 * or 0xFF if no MOb available	*/
char Can_get_MOB_free (void)
{
/*Macro_Can_get_MOB_free_Start*/
  char num_MOB, Save_page;

  Save_page = CANPAGE;
  for (num_MOB = 0; num_MOB < NB_MOB; num_MOB++)
  {
    Can_set_MOB(num_MOB);
    if ((CANCDMOB&0xC0) == 0x00) // Disable configuration
    {
      CANPAGE = Save_page;
      return (num_MOB);
    }
  }
  CANPAGE = Save_page;
  return (NO_MOB);
/*Macro_Can_get_MOB_free_End*/
}


/* NAME: Can_get_MOB_status
 * return: mob_status : MOB_COMPLETED | MOB_NOT_COMPLETED | MOB_DISABLE
 * PURPOSE: This function return information MOB completed its job
 * (MOB_COMPLETED) if one of the RXOK or TXOK Flag is set or MOB not completed
 * its job (MOB_NOT_COMPLETED) if no RXok and TXOK flags are set.
 * Previously, this function check if the MOb is configured or not.
 * In the case of the MOB is not configured, the function return MOB_DISABLE. */
char Can_get_MOB_status (void)
{
/*Macro_Can_get_MOB_status_Start*/
  /* test if mob is completed*/
  if (CANSTMOB&(1<<TXOK))     {return(MOB_TX_COMPLETED);}
  if (CANSTMOB&(1<<RXOK))     {return(MOB_RX_COMPLETED);}
  /* test if mob enabled */
  if ((CANCDMOB&0xC0) == 0x00){return(MOB_DISABLE);}
  return(MOB_NOT_COMPLETED);
/*Macro_Can_get_MOB_status_End*/
}


/* FUNCTION_NAME: Can_get_data
 * PARAMS:   address pointer to data array
 * PURPOSE: This function copy the data from the selected MOb to the address
 * passed in parameter.  */
void Can_get_data (char * pt_data)
{
/*Macro_Can_get_data_Start*/
  char nb_data;

  for (nb_data = 0; nb_data <(CANCDMOB&DLC_msk); nb_data++)
  {
    *(pt_data + nb_data) = CANMSG;
  }
/*Macro_Can_get_data_End*/
}


/* FUNCTION_NAME: can_init
 * PURPOSE: Sets up the CAN boad rate and sets the CAN driver running */
void can_init (void)
{
/*Macro_can_init_Start*/
  Can_bit_timing();
  Can_clear_all_MOB();
  Can_enable();
/*Macro_can_init_End*/
}




/* FUNCTION_NAME: can_read/write command
 * PARAMS:   Mailbox st_cmd_t
 * return: command_status : CAN_CMD_REFUSED | CAN_CMD_ACCEPTED
 * PURPOSE: Reads or Writes a CAN packet via a mailbox */
char can_cmd (st_cmd_t* cmd)
{
/*Macro_can_cmd_Start*/
  char mob_handle, cpt;

  if (cmd->cmd == CMD_ABORT)
  {
    if (cmd->status!= STATUS_MOB_AVAILABLE)
    {
      Can_set_MOB(cmd->handle);
      Can_MOB_abort();
      cmd->handle = 0;
      cmd->status = STATUS_MOB_AVAILABLE;
    }
  }
  else
  {
    mob_handle = Can_get_MOB_free();
    cmd->status = STATUS_MOB_USED;

    if (mob_handle!= NO_MOB)
    {
      cmd->handle = mob_handle;
      Can_set_MOB(mob_handle);
      Can_clear_MOB();
      switch (cmd->cmd){
        case CMD_TX:
          if (cmd->ctrl.ide){ Can_set_ext_id (cmd->id.ext);}
          else               { Can_set_std_id(cmd->id.std);}
          for (cpt=0;cpt<cmd->dlc;cpt++) CANMSG = *(cmd->pt_data + cpt);
          Can_set_dlc(cmd->dlc);
          Can_config_tx();
          break;

        case CMD_TX_REMOTE:
          if (cmd->ctrl.ide){ Can_set_ext_remote_id (cmd->id.ext);}
          else               { Can_set_std_remote_id(cmd->id.std);}
          Can_set_dlc(cmd->dlc);
          Can_config_tx();
          break;

        case CMD_RX:
          Can_config_rx();
          break;

        default:
           cmd->status = STATUS_MOB_AVAILABLE;
         break;
      }
    }else {return CAN_CMD_REFUSED;}
  }
  return CAN_CMD_ACCEPTED;
/*Macro_can_cmd_End*/
}



/* FUNCTION_NAME: can_getstatus
 * PARAMS:   Mailbox st_cmd_t
 * return: mailbox_status : CAN_STATUS_COMPLETED | CAN_STATUS_DISABLED | status
 * PURPOSE: Checks the status of a mailbox */
char can_getstatus (st_cmd_t* cmd)
{
/*Macro_can_getstatus_Start*/
  char status;

  if (cmd->status == STATUS_MOB_AVAILABLE) {return CAN_STATUS_DISABLED;}
  Can_set_MOB(cmd->handle);
  status = Can_get_MOB_status();
  if (status == MOB_RX_COMPLETED)
  {
    cmd->status = 0;
    cmd->dlc = Can_get_dlc();
    Can_get_data(cmd->pt_data,0);
    cmd->ctrl.rtr = Can_get_rtr();

    if (Can_get_ide()) // if extended frame
    {
      cmd->ctrl.ide = 1; // extended frame
      Can_get_ext_id(cmd->id.ext);
    }
    else // else standard frame
    {
      cmd->ctrl.ide = 0;
      Can_get_std_id(cmd->id.std);
    }
    Can_MOB_abort(); // freed the MOB
    return CAN_STATUS_COMPLETED;

  }else if (status == MOB_TX_COMPLETED)
  {
    cmd->status = 0;
    Can_MOB_abort(); // freed the MOB
    return CAN_STATUS_COMPLETED;
  }

  return (status);
/*Macro_can_getstatus_End*/
}


void Init(void)
{
/*Macro_Init_Start*/
	return;
/*Macro_Init_End*/
}



void SendBuffer(void)
{
/*Macro_SendBuffer_Start*/

	char retry = 255;		//Specifies number of retries
	tx_msg.cmd = CMD_TX;

	while (retry)
	{
		if( can_cmd(&tx_msg) == CAN_CMD_ACCEPTED );
		{
			while( can_getstatus(&tx_msg) != CAN_STATUS_COMPLETED );
			return;
		}
		retry = retry - 1;
	}
/*Macro_SendBuffer_End*/
}


char CheckRx(void)
{
/*Macro_CheckRx_Start*/

	short retry;				//Specifies number of retries
	static char command_sent = 0;

	rx_msg.cmd = CMD_RX;		//Receive Mode

	if(command_sent == 0)
	{
		if( can_cmd(&rx_msg) == CAN_CMD_ACCEPTED )
		{
			command_sent = 1;
		}
	}

	if(command_sent == 1)
	{
		if( can_getstatus(&rx_msg) == CAN_STATUS_COMPLETED )
		{
			command_sent = 0;
			return 1;
		}

	}

	return 0;

/*Macro_CheckRx_End*/
}



char GetRxDataCount(void)
{
/*Macro_GetRxDataCount_Start*/

	return rx_msg.dlc;

/*Macro_GetRxDataCount_End*/
}


char GetRxData(char index)
{
/*Macro_GetRxData_Start*/

	if (index > rx_msg.dlc)
	{
	   return (0);
	}
	return (rx_buffer[index]);

/*Macro_GetRxData_End*/
}


void SetTxData(char data_cnt, char d0, char d1, char d2, char d3, char d4, char d5, char d6, char d7)
{
/*Macro_SetTxData_Start*/

	if (data_cnt > 8)
	{
	   return;
	}

	tx_msg.dlc = data_cnt;

	if (data_cnt > 0)
	{
	   tx_buffer[0] = d0;
	   if (data_cnt > 1)
	   {
		   tx_buffer[1] = d1;
		   if (data_cnt > 2)
		   {
			   tx_buffer[2] = d2;
			   if (data_cnt > 3)
			   {
				   tx_buffer[3] = d3;
				   if (data_cnt > 4)
				   {
					   tx_buffer[4] = d4;
					   if (data_cnt > 5)
					   {
						   tx_buffer[5] = d5;
						   if (data_cnt > 6)
						   {
							   tx_buffer[6] = d6;
							   if (data_cnt > 7)
							   {
								   tx_buffer[7] = d7;
							   }
						   }
					   }
				   }
			   }
		   }
	   }
	}

/*Macro_SetTxData_End*/
}


void SetTxID(char hi, char lo)
{
/*Macro_SetTxID_Start*/

	tx_msg.id.std = ((hi << 8) | lo);

/*Macro_SetTxID_End*/
}


char GetRxIDLo(void)
{
/*Macro_GetRxIDLo_Start*/

	return (rx_msg.id.std & 0xFF);

/*Macro_GetRxIDLo_End*/
}


char GetRxIDHi(void)
{
/*Macro_GetRxIDHi_Start*/

	return ((rx_msg.id.std >> 8) & 0xFF);

/*Macro_GetRxIDHi_End*/
}


































