#ifndef CAN_Defs_h
#define CAN_Defs_h

	//Structure Declarations
	//enum is used to select an action for a specific message
	typedef enum {
	  CMD_TX,
	  CMD_TX_REMOTE,
	  CMD_RX,
	  CMD_ABORT
	} can_cmd_t;

	//defines a CAN identifier and allows to access it in mode standart, extended or throught a table.
	typedef union{
	  unsigned long ext;
	  unsigned int std;
	  char  tab[4];
	} can_id_t;

	//defines some specific information as rtr bit and ide bit.
	typedef struct{
	  char rtr : 1;
	  char ide : 1;
	  char dummy :6;
	} can_ctrl_t;

	//defines a specific action on CAN network.
	//handle: manage by the library.
	//cmd   : select the operation
	//id    : ID
	//dlc   : number of data bytes
	//pt_data: pointer on the table which contains the send / received data
	//status: manage by the library
	//ctrl : field rtr to signal a remote frame / field ide to signal a extended frame
	typedef  struct{
	  char      handle;
	  can_cmd_t  cmd;
	  can_id_t   id;
	  char      dlc;
	  char*    pt_data;
	  char      status;
	  can_ctrl_t ctrl;
	} st_cmd_t;


	typedef enum {
	  MOB_0, MOB_1, MOB_2, MOB_3, MOB_4, MOB_5, MOB_6, MOB_7,
	  MOB_8, MOB_9, MOB_10, MOB_11, MOB_12, MOB_13, MOB_14} can_mob_t;

#endif